﻿Type=Class
Version=3.5
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private panelImageView As Panel 
	Private mBitmap As Bitmap 
	
	Private mModule As Object 
	Private mEventname As String 

	Private mOffset As Int 
	Private mScrollSpeed As Int 
	Private mScaleRatio As Float 
	
	Private Scale = 1000dip/1000
	
	Private mRelativePosition As Float 
End Sub

'Sliding Imageview lets the image slide as your scroll
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pModule As Object, pEventname As String, pPanel As Panel)
	mModule = pModule
	mEventname = pEventname
	panelImageView = pPanel
	mOffset = 0
	mScaleRatio = 1
End Sub

Public Sub SetBitmap(pBitmap As Bitmap)
	mBitmap = pBitmap
End Sub

'Off centre scroll
Public Sub SetOffset(pOffset As Int)
	mOffset = pOffset
End Sub

'If scrolling bitmap is not the same size as original bitmap
Public Sub SetScaleRatio(pScaleRatio As Float)
	mScaleRatio = pScaleRatio
End Sub

'Allow for parallax
'Public Sub SetMaxHeight(pMaxHeight As Int)

'End Sub


'Can be improved with AS
Public Sub HandleDrag(RelativePosition As Float)
	If mBitmap.IsInitialized = False OR mBitmap = Null Then Return
	
	Dim c As Canvas
	c.Initialize(panelImageView)
	Dim srcRect, destRect As Rect 
	Dim relPos As Float = RelativePosition

	Dim startHeight As Int = relPos * mBitmap.Height * Scale 
	startHeight = startHeight + (mOffset / mScaleRatio)
	srcRect.Initialize(0, startHeight/Scale, panelImageView.Width/(Scale*mScaleRatio), (startHeight + panelImageView.Height/mScaleRatio)/(Scale))
	destRect.Initialize(0,0, panelImageView.Width , panelImageView.Height)
	c.DrawBitmap(mBitmap,  srcRect, destRect)
	
	panelImageView.Invalidate
	
End Sub
